const std = @import("std");

pub fn main() !void {
    const n: i32 = -27;
    const res = try getMostDivisors(n);
    defer res.deinit();

    if (res.items.len == 0) return;

    const stdout = std.io.getStdOut().writer();
    try stdout.print("From 1 to {d}, {d} has the most ({d}) divisors:\n[", .{ n, res.items[res.items.len - 1], res.items.len });
    const last_item = res.items[res.items.len - 1];
    var chr = ", ";

    for (res.items) |i| {
        if (i == last_item) chr = "]\n";
        try stdout.print("{d}{s}", .{ i, chr });
    }
}

fn getMostDivisors(n: i32) !std.ArrayList(usize) {
    const nc: usize = @intCast(@abs(n));
    const allocator = std.heap.page_allocator;
    var res = std.ArrayList(usize).init(allocator);

    for (1..nc + 1) |i| {
        const div = try getDivisors(allocator, i);
        if (div.items.len > res.items.len) {
            res = div;
        }
    }

    return res;
}

fn getDivisors(alloc: std.mem.Allocator, n: usize) !std.ArrayList(usize) {
    var divs = std.ArrayList(usize).init(alloc);

    for (1..n + 1) |i| {
        if (n % i == 0) try divs.append(i);
    }

    return divs;
}
